using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace Akadia
{
	public class ParamQuery : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox lbFound;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtFind;
		private System.Windows.Forms.Button btnFind;

		private System.ComponentModel.Container components = null;

		public ParamQuery()
		{
			// Initialize Controls
			InitializeComponent();
		}

		// Clean up any resources being used.
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
this.btnFind = new System.Windows.Forms.Button();
this.lbFound = new System.Windows.Forms.ListBox();
this.label1 = new System.Windows.Forms.Label();
this.txtFind = new System.Windows.Forms.TextBox();
this.SuspendLayout();
// 
// btnFind
// 
this.btnFind.Location = new System.Drawing.Point(8, 232);
this.btnFind.Name = "btnFind";
this.btnFind.Size = new System.Drawing.Size(280, 32);
this.btnFind.TabIndex = 0;
this.btnFind.Text = "Find";
this.btnFind.Click += new System.EventHandler(this.btnFind_Click);
// 
// lbFound
// 
this.lbFound.Location = new System.Drawing.Point(8, 56);
this.lbFound.Name = "lbFound";
this.lbFound.Size = new System.Drawing.Size(280, 173);
this.lbFound.TabIndex = 1;
// 
// label1
// 
this.label1.Location = new System.Drawing.Point(8, 19);
this.label1.Name = "label1";
this.label1.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
this.label1.Size = new System.Drawing.Size(34, 16);
this.label1.TabIndex = 2;
this.label1.Text = "Find";
// 
// txtFind
// 
this.txtFind.Location = new System.Drawing.Point(48, 16);
this.txtFind.Name = "txtFind";
this.txtFind.Size = new System.Drawing.Size(240, 20);
this.txtFind.TabIndex = 3;
this.txtFind.Text = "";
// 
// ParamQuery
// 
this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
this.ClientSize = new System.Drawing.Size(292, 269);
this.Controls.AddRange(new System.Windows.Forms.Control[] {
            this.txtFind,
            this.label1,
            this.lbFound,
            this.btnFind});
this.Name = "ParamQuery";
this.Text = "Parameterized Query / DataReader";
this.ResumeLayout(false);

		}
		#endregion

		// The main entry point for the application.
		static void Main() 
		{
			Application.Run(new ParamQuery());
		}

		// Find the Employee and display it in the List Box
		private void btnFind_Click(object sender, System.EventArgs e)
		{
			SqlDataReader rdr = null;
			SqlConnection con = null;
			SqlCommand cmd = null;

			try
			{
				// Open connection to the database
				string ConnectionString = "server=xeon;uid=sa;"+
					"pwd=manager; database=northwind";
				con = new SqlConnection(ConnectionString);
				con.Open();

				// Set up a command with the given query and associate
				// this with the current connection. 
				string CommandText = "SELECT FirstName, LastName" +
					"  FROM Employees" +
					" WHERE (LastName LIKE @Find)";
				cmd = new SqlCommand(CommandText);
				cmd.Connection = con;

				// Add LastName to the above defined paramter @Find 
				cmd.Parameters.Add(
					new SqlParameter(
					"@Find", // The name of the parameter to map
					System.Data.SqlDbType.NVarChar, // SqlDbType values
					20, // The width of the parameter
					"LastName"));  // The name of the source column

				// Fill the parameter with the value retrieved from the text field
				cmd.Parameters["@Find"].Value = txtFind.Text;

				// Execute the query
				rdr = cmd.ExecuteReader();

				// Fill the list box with the values retrieved
				lbFound.Items.Clear();
				while(rdr.Read())
				{
					lbFound.Items.Add(rdr["FirstName"].ToString() +
				    " " + rdr["LastName"].ToString());
				}
			}
			catch(Exception ex)
			{
				// Print error message
				MessageBox.Show(ex.Message);
			}
			finally
			{
				// Close data reader object and database connection
				if (rdr != null)
					rdr.Close();
				
				if (con.State == ConnectionState.Open)
					con.Close();
			}
		}
	}
}
