using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace Akadia
{
	public class SqlBrowser : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox orderIDsList;
		private System.Windows.Forms.ListView orderDetailsList;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.ComponentModel.Container components = null;
		private System.Data.SqlClient.SqlConnection con;
		private System.Windows.Forms.Button btnStart;
		private bool _columnsSet = false;

		public SqlBrowser()
		{
			// Create Controls
			InitializeComponent();

			// Setup Connection
			string strCon = "server=xeon;uid=sa;" +
				"pwd=manager; database=northwind";
			con = new SqlConnection(strCon);
		}

		// Clean up any resources being used.
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.orderIDsList = new System.Windows.Forms.ListBox();
			this.btnStart = new System.Windows.Forms.Button();
			this.orderDetailsList = new System.Windows.Forms.ListView();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// orderIDsList
			// 
			this.orderIDsList.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.orderIDsList.Location = new System.Drawing.Point(8, 24);
			this.orderIDsList.Name = "orderIDsList";
			this.orderIDsList.Size = new System.Drawing.Size(152, 303);
			this.orderIDsList.TabIndex = 0;
			this.orderIDsList.SelectedIndexChanged += new System.EventHandler(this.orderIDsList_SelectedIndexChanged);
			// 
			// btnStart
			// 
			this.btnStart.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.btnStart.Location = new System.Drawing.Point(408, 336);
			this.btnStart.Name = "btnStart";
			this.btnStart.TabIndex = 1;
			this.btnStart.Text = "&Start";
			this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
			// 
			// orderDetailsList
			// 
			this.orderDetailsList.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.orderDetailsList.Location = new System.Drawing.Point(176, 24);
			this.orderDetailsList.Name = "orderDetailsList";
			this.orderDetailsList.Size = new System.Drawing.Size(312, 304);
			this.orderDetailsList.TabIndex = 2;
			this.orderDetailsList.View = System.Windows.Forms.View.Details;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "Order ID";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(176, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "Order Details";
			// 
			// SqlBrowser
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 365);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label2,
																		  this.label1,
																		  this.orderDetailsList,
																		  this.btnStart,
																		  this.orderIDsList});
			this.Name = "SqlBrowser";
			this.Text = "Using DataReader / Stored Procedure";
			this.ResumeLayout(false);

		}
		#endregion

		// The main entry point for the application.
		static void Main() 
		{
			Application.Run(new SqlBrowser());
		}

		// Fill orderIDsList with OrderID's
		private void btnStart_Click(object sender, System.EventArgs e)
		{
			int iOrderID;

			// Create a command to select the Order IDs from the ORDERS table
			SqlCommand command = new SqlCommand
				("SELECT OrderID from ORDERS", con);

			// Open the connection
			con.Open();

			// Get the data reader
			SqlDataReader reader = command.ExecuteReader();

			// Process each result
			while (reader.Read())
			{
				// Add each order ID in the result to the list 
				// view containing the orders IDs. We have only 
				// selected a single column in this code so we
				// can be pretty save in using reader.GetInit32(0)
				// there are no more columns in the data reader.
				iOrderID = reader.GetOrdinal("OrderID");
				orderIDsList.Items.Add (reader.GetInt32(iOrderID));
			}

			// Close the reader and the connection
			reader.Close();
			this.con.Close();
		}

		// Populate the list view with the order details
		// 
		// Used Stored Procedure:
		// ----------------------
		// CREATE PROCEDURE CustOrdersDetail @OrderID int
		// AS
		// SELECT ProductName,
		//		  UnitPrice=ROUND(Od.UnitPrice, 2),
		//		  Quantity,
		//        Discount=CONVERT(int, Discount * 100), 
		//		  ExtendedPrice=ROUND(CONVERT(money, Quantity * 
		//        (1 - Discount) * Od.UnitPrice), 2)
		//   FROM Products P, [Order Details] Od
		//  WHERE Od.ProductID = P.ProductID and Od.OrderID = @OrderID
		//
		private void orderIDsList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Get the selected item and convert it to the correct order ID
			int orderID = Convert.ToInt32(orderIDsList.SelectedItem);

			// Create a command to execute a stored procedure
			SqlCommand storedProcCommand = new SqlCommand ("CustOrdersDetail", con);

			// Let the command know it will be executed a stored procedure
			storedProcCommand.CommandType = CommandType.StoredProcedure;

			// Add a parameter that's passed to the stored proc, 
			// this is the order ID we selected
			storedProcCommand.Parameters.Add("@OrderID",orderID);

			// Open the connection
			con.Open ();

			// Create an ArrayList to hold the results
			ArrayList rowList = new ArrayList();

			// Get the reader
			SqlDataReader reader = storedProcCommand.ExecuteReader();

			// Process each result in the result set
			while (reader.Read())
			{
				// Create an array big enough to hold the column values
				object[] values = new object[reader.FieldCount];

				// Get the column values into the array
				reader.GetValues(values);

				// Add the array to the ArrayList
				rowList.Add ( values );
			}

			// Have the columns already being added to the list view?
			if (_columnsSet == false)
			{
				// No, so get the schema for this result set
				DataTable schema = reader.GetSchemaTable();

				// And set the list view to reflect the contents of the schema
				SetColumnHeaders(schema);
			}

			// Close the reader and the connection
			reader.Close ();
			con.Close ();

			// Now populate the list view with the order details
			PopulateOrderDetails(rowList);
		}

		// Populate the list view with the order details
		private void PopulateOrderDetails (ArrayList rowList)
		{
			// Clear any exsisting items from the orders view
			orderDetailsList.Items.Clear();

			// Now process each array in the arraylist
			foreach (object[] row in rowList)
			{
				// Create a string array large enough to hold all
				// the column values in this array
				string[] orderDetails = new string[row.Length];

				// Create a column index into the array
				int columnIndex = 0;

				// Now process each column value
				foreach (object column in row)
				{
					// Convert the value to a string and stick it in the string array
					orderDetails[columnIndex++] = Convert.ToString (column);
				}
					
				// Now use the string array to create a new item to go in the list view
				ListViewItem newItem = new ListViewItem (orderDetails);

				// Finally add the new item to the view
				orderDetailsList.Items.Add (newItem);
			}
		}

		// Set the list view to reflect the contents of the schema
		private void SetColumnHeaders (DataTable schema)
		{
			// Process each row in the schema table
			foreach (DataRow row in schema.Rows)
			{
				// For each column add a new column to the list view
				orderDetailsList.Columns.Add((string)row["ColumnName"],
					50, HorizontalAlignment.Left);
			}

			// Set this flag to stop the method being called again
			_columnsSet = true;
		}
	}
}
